﻿
package sandy.events
{
	import flash.events.Event;

	/**
	 * BubbleEvent defines a custom event type to work with.
	 *
	 * @author	Thomas Pfeiffer
	 * @version		3.1
	 *
	 * @see BubbleEventBroadcaster
	 */
	public class BubbleEvent extends Event
	{
		private var m_oTarget:Object;
		//private var m_sType:String;

		/**
		 * Creates a new BubbleEvent instance.
	 	 *
		 * @example
		 * <listing version="3.1">
		 *   var e:BubbleEvent = new BubbleEvent(MyClass.onSomething, this);
		 * </listing>
		 *
		 * @param e		A name for the event.
		 * @param oT	The event target.
		 */
		public function BubbleEvent(e:String, oT:Object)
		{
			super(e, true, true);
			m_oTarget = oT;
		}

		/**
		 * The event target.
		 */
		public function get object():Object
		{
			return m_oTarget;
		}
		

		/**
		 * Returns the string representation of the event.
		 *
		 * @return String representation of this instance.
		 */
		public override function toString():String
		{
			return "BubbleEvent";
		}
	}
}